/*
 * Copyright (C) 2004 Tilman Sauerbeck (tilman at code-monkey de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __RB_EDJE_MAIN_H
#define __RB_EDJE_MAIN_H

#define GET_OBJ(obj, type, o) \
	type *(o) = NULL; \
\
	Data_Get_Struct ((obj), type, (o));

#define CHECK_BOOL(val) \
	if (TYPE ((val)) != T_TRUE && TYPE ((val)) != T_FALSE) { \
		rb_raise (rb_eTypeError, \
		          "wrong argument type %s (expected true or false)", \
		          rb_obj_classname ((val))); \
		return Qnil; \
	}

#define CHECK_CLASS(val, klass) \
	if (!rb_obj_is_kind_of ((val), (klass))) { \
		rb_raise (rb_eTypeError, \
		          "wrong argument type %s (expected %s)", \
		          rb_obj_classname ((val)), \
		          rb_class2name ((klass))); \
		return Qnil; \
	}

VALUE mEdje;

#endif
